<template>
		<el-dialog
			v-model="state.dialogVisible"
			draggable
			title="撤销工单"
			@mouseup="mouseup"
			:style="'transform: ' + state.transform + ';'"
			ref="dialogRef"
			append-to-body
      :before-close="handleClose"
      destroy-on-close
      @close="close"
		>
			<el-form :model="state.ruleForm" label-width="90px" ref="ruleFormRef">
				<el-row :gutter="35">
					<el-col :xs="24" :sm="12" :md="12" :lg="12" :xl="12">
						<el-form-item label="工单编码">
							{{ state.orderDetail.no }}
						</el-form-item>
					</el-col>
					<el-col :xs="24" :sm="12" :md="12" :lg="12" :xl="12">
						<el-form-item label="工单标题">
							{{ state.orderDetail.title }}
						</el-form-item>
					</el-col>
					<el-col :xs="24" :sm="12" :md="12" :lg="12" :xl="12">
						<el-form-item label="撤销人">
							{{ userInfos.name }}
						</el-form-item>
					</el-col>
					<el-col :xs="24" :sm="12" :md="12" :lg="12" :xl="12">
						<el-form-item label="撤销部门">
							{{ userInfos.orgName }}
						</el-form-item>
					</el-col>
					<el-col :xs="24" :sm="12" :md="12" :lg="12" :xl="12">
						<el-form-item label="撤销时间">
							{{ formatDate(Date(), 'YYYY-mm-dd HH:MM:SS') }}
						</el-form-item>
					</el-col>
					<el-col :xs="24" :sm="12" :md="12" :lg="12" :xl="12">
						<el-form-item label="撤销短信" prop="acceptSms" :rules="[{ required: false, message: '请选择发送督办短信', trigger: 'change' }]">
							<el-checkbox v-model="state.ruleForm.acceptSms" label="发送撤销短信" />
						</el-form-item>
					</el-col>
					<el-col :xs="24" :sm="24" :md="24" :lg="24" :xl="24">
						<el-form-item label="撤销原因" class="textarea" prop="opinion" :rules="[{ required: true, message: '请填写撤销原因', trigger: 'blur' }]">
							<common-advice
								@chooseAdvice="chooseAdvice"
								v-model="state.ruleForm.opinion"
								placeholder="请填写撤销原因"
								:loading="state.loading"
								:commonEnum="commonEnum['OrderCirculation']"
							/>
						</el-form-item>
					</el-col>
					<el-col :xs="24" :sm="24" :md="24" :lg="24" :xl="24">
						<el-form-item label="附件" prop="additions">
							<annex-list name="撤销附件" ref="annexListRef" :businessId="state.orderDetail.id" classify="撤销上传"/>
						</el-form-item>
					</el-col>
				</el-row>
			</el-form>
			<template #footer>
				<span class="dialog-footer">
					<el-button @click="onCancel" class="default-button">取 消</el-button>
					<el-button type="primary" @click="onSubmit(ruleFormRef)" :loading="state.loading">提 交</el-button>
				</span>
			</template>
		</el-dialog>
</template>

<script setup lang="ts" name="orderRevokeDialog">
import { reactive, ref, defineAsyncComponent } from 'vue';
import { ElMessageBox, FormInstance } from 'element-plus';
import { throttle } from '/@/utils/tools';
import { storeToRefs } from 'pinia';
import { useUserInfo } from '/@/stores/userInfo';
import { formatDate } from '/@/utils/formatTime';
import { commonEnum } from '/@/utils/constants';
import {workflowCancel} from "/@/api/system/workflow"


// 引入组件
const AnnexList = defineAsyncComponent(() => import('/@/components/AnnexList/index.vue')); // 附件列表
const CommonAdvice = defineAsyncComponent(() => import('/@/components/CommonAdvice/index.vue')); // 常用意见

// 定义子组件向父组件传值/事件
const emit = defineEmits(['onSupplySuccess']);
// 定义变量内容
const state = reactive<any>({
	dialogVisible: false,
	ruleForm: {
		opinion: '', // 撤销原因
    acceptSms:false,// 是否发送短信
		workflowId: '', // 流程id
	},
  orderDetail:{},// 工单详情
	loading: false, // 提交按钮loading
  transform: 'translate(0px, 0px)', // 滚动条位置
});
const ruleFormRef = ref<RefType>();
const storesUserInfo = useUserInfo();
const { userInfos } = storeToRefs(storesUserInfo); // 用户信息
// 打开弹窗
const openDialog = async (val: any) => {
	state.orderDetail = val;
	state.ruleForm.workflowId = val.workflowId;
	state.dialogVisible = true;
};
// 关闭弹窗
const closeDialog = () => {
  ruleFormRef.value.clearValidate();
  ruleFormRef.value.resetFields();
	state.dialogVisible = false;
};
const close = ()=>{
  ruleFormRef.value.clearValidate();
  ruleFormRef.value.resetFields();
}
// 取消
const onCancel = () => {
	closeDialog();
};
const handleClose = (done: any) => {
  closeDialog();
  done();
};
// 选中常用意见
const chooseAdvice = (item: any) => {
	state.ruleForm.opinion += item.content;
};
// 设置抽屉
const dialogRef = ref<RefType>();
const mouseup = () => {
	state.transform = dialogRef.value.dialogContentRef.$el.style.transform;
};
// 提交
const annexListRef = ref<RefType>(); // 附件列表
const onSubmit = throttle((formEl: FormInstance | undefined) => {
	if (!formEl) return;
	formEl.validate((valid: boolean) => {
		if (!valid) return;
		ElMessageBox.confirm(`确认撤销?`, '提示', {
			confirmButtonText: '确认',
			cancelButtonText: '取消',
			type: 'warning',
			draggable: true,
			cancelButtonClass: 'default-button',
			autofocus: false,
		})
			.then(() => {
				state.loading = true;
        let request = {
          ...state.ruleForm,
          files:annexListRef.value?.fileList,
        }
        workflowCancel(request)
					.then(() => {
						state.loading = false;
						state.dialogVisible = false;
						emit('onSupplySuccess');
					})
					.catch(() => {
						state.loading = false;
						state.dialogVisible = false;
					});
			})
			.catch(() => {});
	});
}, 300);
// 暴露变量
defineExpose({
	openDialog,
	closeDialog,
});
</script>
<style lang="scss" scoped></style>
